//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtArbolJT2.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

ArbolJT2::ArbolJT2(const tJuegoLogT2& EJ, int nivel, FunHeuristicaT2 fh)
{
        datoT2 aux;
        aux.juego = EJ.clona();
        arbol = new ArbolJ(aux);
        this->nivel = nivel;
        FH = fh;
        generaArbol(arbol, nivel);
         // poda alfa beta
}

void ArbolJT2::liberaArbol(ArbolJ *a)
{
        delete a->getDato().juego;
        for(unsigned int i = 0; i < a->numHijos(); i++)
        {
                liberaArbol(a->getHijo(i));
                delete a->getHijo(i);
        }
}

void ArbolJT2::generaArbol(ArbolJ *arbol, int nivel)
{
        if(nivel > 0)
        {
                Casilla cf;
                datoT2 aux;
                ArbolJ* arb;
                for(unsigned int i = 0; i < arbol->getDato().juego->getCols(); i++)
                {
                        for(unsigned int j = 0; j < arbol->getDato().juego->getFils(); j++)
                        {
                                cf.x = i;
                                cf.y = j;
                                if(arbol->getDato().juego->sePuede(cf))
                                {
                                        aux.jugada = cf;
                                        aux.juego = arbol->getDato().juego->clona();
                                        aux.juego->aplicaJugada(aux.jugada);
                                        arb = new ArbolJ(aux);
                                        arbol->addHijo(arb);
                                        generaArbol(arb, nivel - 1);
                                }
                        }
                }
        }
}

Casilla ArbolJT2::buscaMejorJugada() throw(EJugador)
{
        if(arbol->numHijos() > 0)
        {
                unsigned int hijo = 0;
                int fh = buscaMiniMax(arbol->getHijo(hijo));
                int fhprov;
                for(unsigned int i = 1; i < arbol->numHijos(); i++)
                {
                        fhprov = buscaMiniMax(arbol->getHijo(i));
                        if(fhprov > fh)
                        {
                                fh = fhprov;
                                hijo = i;
                        }
                }
                Casilla cf = arbol->getHijo(hijo)->getDato().jugada;
                return cf;
        }
        else throw EJugador();
}

int ArbolJT2::buscaMiniMax(ArbolJ* a)
{
        if(a->numHijos() == 0)
        {
                return FH(*(a->getDato().juego));
        }
        else
        {
                int fhfinal, fhprovisional;
                fhfinal = buscaMiniMax(a->getHijo(0));
                if(a->getDato().juego->getTurno() == Ja )
                {
                        for(unsigned int i = 1; i < a->numHijos(); i++)
                        {
                                fhprovisional = buscaMiniMax(a->getHijo(i));
                                if(fhprovisional < fhfinal)
                                        fhfinal = fhprovisional;
                        }
                }
                else
                {
                        for(unsigned int i = 1; i < a->numHijos(); i++)
                        {
                                fhprovisional = buscaMiniMax(a->getHijo(i));
                                if(fhprovisional > fhfinal)
                                        fhfinal = fhprovisional;
                        }
                }
                return fhfinal;
        }
}
