//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJuegoConecta4.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
tJuegoConecta4::tJuegoConecta4(const tJuegoConecta4& juego):tJuegoLogT2(juego)
{
        this->libres = juego.libres;
}

void tJuegoConecta4::aplicaJugada(unsigned int c, unsigned int f) throw(EJuego)
{
        if((tablero != NULL) && sePuede(c,f))
        {
                int i = tablero->getFils() - 1;
                Turno aux;
                while((i >= 0) && (aux != Jn))
                {
                        tablero->getElem(c, i--, aux);
                }
                tablero->setElem(c, i + 1, turno);
                libres--;
                hayGanador = fin();
                if(!hayGanador)
                {
                        if(turno == Ja)
                        {
                                turno = Jb;
                        }
                        else turno = Ja;
                }
        }
        else throw EJuego("Error de juego: La columna esta llena.");
} //: mtodo abstracto que aplica la jugada caracterizada por la posicin (c,f) del tablero. Si dicha jugada no es legal se lanza una excepcin.

bool tJuegoConecta4::sePuede(unsigned int c,unsigned int f) const throw()
{
        if((f == 0) && (c < tablero->getCols()))
        {
                Turno aux;
                tablero->getElem(c, f, aux);
                return aux == Jn;
        }
        else return false;
} // : dice si la jugada caracterizada por (c,f) es una jugada legal.

bool tJuegoConecta4::fin() const throw()
{
        if(libres > 0 && !hayGanador)
        {
                bool ganador = false;
                unsigned int i = 0, j = 3;
                Turno a1, a2, a3, a4;
                while((!ganador) && (i < tablero->getCols()))
                { // 4 seguidas en vertical
                        while((!ganador) && (j < tablero->getFils()))
                        {
                                tablero->getElem(i, j - 3, a1);
                                tablero->getElem(i, j - 2, a2);
                                tablero->getElem(i, j - 1, a3);
                                tablero->getElem(i, j, a4);
                                ganador = ((a1 == a2) && (a1 == a3) && (a1 == a4) && (a1 != Jn));
                                j++;
                        }
                        i++;
                        j = 3;
                }
                i = 3;
                j = 0;
                while((!ganador) && (j < tablero->getFils()))
                { // 4 seguidas en horizontal
                        while((!ganador) && (i < tablero->getCols()))
                        {
                                tablero->getElem(i - 3, j, a1);
                                tablero->getElem(i - 2, j, a2);
                                tablero->getElem(i - 1, j, a3);
                                tablero->getElem(i++, j, a4);
                                ganador = ((a1 == a2) && (a1 == a3) && (a1 == a4) && (a1 != Jn));
                        }
                        ++j;
                        i = 3;
                }
                i = 3;
                j = 3;
                while((!ganador) && (i < tablero->getCols()))
                { // 4 seguidas en diagonal 1-9
                        while((!ganador) && (j < tablero->getFils()))
                        {
                                tablero->getElem(i - 3, j, a1);
                                tablero->getElem(i - 2, j - 1, a2);
                                tablero->getElem(i - 1, j - 2, a3);
                                tablero->getElem(i, j - 3, a4);
                                ganador = ((a1 == a2) && (a1 == a3) && (a1 == a4) && (a1 != Jn));
                                j++;
                        }
                        i++;
                        j = 3;
                }
                i = 3;
                j = 3;
                while((!ganador) && (i < tablero->getCols()))
                { // 4 seguidas en diagonal 7-3
                        while((!ganador) && (j < tablero->getFils()))
                        {
                                tablero->getElem(i - 3, j - 3, a1);
                                tablero->getElem(i - 2, j - 2, a2);
                                tablero->getElem(i - 1, j - 1, a3);
                                tablero->getElem(i, j, a4);
                                ganador = ((a1 == a2) && (a1 == a3) && (a1 == a4) && (a1 != Jn));
                                j++;
                        }
                        i++;
                        j = 3;
                }
                return ganador;
        }
        else return true;
} //: indica si no se pueden realizar ms jugadas.

tJuegoLogT2* tJuegoConecta4::clona() const
{
        return new tJuegoConecta4(*this);
} //: devuelve un puntero a una copia del juego actual.


