//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJuegoOtelo.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

tJuegoOtelo::tJuegoOtelo(Turno t):tJuegoLogT2(9, 8, t)
{
        libres = 60;
        tablero->setElem(3, 3, Ja);
        tablero->setElem(4, 3, Jb);
        tablero->setElem(3, 4, Jb);
        tablero->setElem(4, 4, Ja);
        fichas[0] = 2;
        fichas[1] = 2;
        haPasado = false;
}

void tJuegoOtelo::aplicaJugada(unsigned int c, unsigned int f) throw(EJuego)
{
        if((tablero != NULL) && sePuede(c, f))
        {
                if(c == 8) // Pasamos (La comprobacion la hace sePuede
                {
                        if(!haPasado)
                        {
                                if(turno == Ja)
                                {
                                        turno = Jb;
                                }
                                else turno = Ja;
                                haPasado = true;
                        }
                        else
                        {
                                hayGanador = true;
                                if(fichas[0] > fichas[1])
                                {
                                        turno = Ja;
                                }
                                else turno = Jb;
                        }
                }
                else // Partida normal
                {
                        haPasado = false;
                        tablero->setElem(c, f, turno);
                        --libres;
                        if(turno == Ja)
                        {
                                ++fichas[0];
                        }
                        else ++fichas[1];
                        mutaLineas(c, f);
                        hayGanador = fin();
                        if(!hayGanador)
                        {
                                if(turno == Ja)
                                {
                                        turno = Jb;
                                }
                                else turno = Ja;
                        }
                        else
                        {
                                if(fichas[0] > fichas[1])
                                {
                                        turno = Ja;
                                }
                                else turno = Jb;
                        }
                }

        }
        else throw EJuego();
}

bool tJuegoOtelo::sePuede(unsigned int c, unsigned int f) const throw()
{
        if(c == 8)
        {
                unsigned int i = 0, j = 0;
                bool sepuede = false;
                while(i < 8 && !sepuede)
                {
                        while(j < 8 && !sepuede)
                        {
                                sepuede = sePuede(i, j++);
                        }
                        j = 0;
                        i++;
                }
                return !sepuede;
        }
        else
        {
                if(libres > 0)
                {
                        Turno aux;
                        tablero->getElem(c, f, aux);
                        return ((aux == Jn) && (compruebaLinea(c, f)));
                }
                else return false;
        }
}

bool tJuegoOtelo::fin() const throw()
{
        return (hayGanador || (libres == 0));
}

tJuegoLogT2* tJuegoOtelo::clona() const
{
        return new tJuegoOtelo(*this);
}

bool tJuegoOtelo::compruebaLinea(unsigned int c, unsigned int f) const
{
        bool valido = false;
        Turno rival, aux;
        int i, j;
        if(turno == Ja)
        {
                rival = Jb;
        }
        else rival = Ja;
        if((c > 0) && !valido)
        {
                i = c - 1;
                tablero->getElem(i, f, aux);
                while((aux == rival) && (i > 0))
                {
                        tablero->getElem(--i, f, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(c) - 1)));
        }
        if((c < 7) && !valido)
        {
                i = c + 1;
                tablero->getElem(i, f, aux);
                while((aux == rival) && (i < 7))
                {
                        tablero->getElem(++i, f, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(c) + 1)));
        }
        if((f > 0) && !valido)
        {
                i = f - 1;
                tablero->getElem(c, i, aux);
                while((aux == rival) && (i > 0))
                {
                        tablero->getElem(c, --i, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(f) - 1)));
        }
        if((f < 7) && !valido)
        {
                i = f + 1;
                tablero->getElem(c, i, aux);
                while((aux == rival) && (i < 7))
                {
                        tablero->getElem(c, ++i, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(f) + 1)));
        }
        if((c > 0) && (f > 0) && !valido)
        {
                i = c - 1;
                j = f - 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i > 0) && (j > 0))
                {
                        tablero->getElem(--i, --j, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(c) - 1)) && (j != (int(f) - 1)));
        }
        if((c < 7) && (f > 0) && !valido)
        {
                i = c + 1;
                j = f - 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i < 7) && (j > 0))
                {
                        tablero->getElem(++i, --j, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(c) + 1)) && (j != (int(f) - 1)));
        }
        if((c > 0) && (f < 7) && !valido)
        {
                i = c - 1;
                j = f + 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i > 0) && (j < 7))
                {
                        tablero->getElem(--i, ++j, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(c) - 1)) && (j != (int(f) + 1)));
        }
        if((c < 7) && (f < 7) && !valido)
        {
                i = c + 1;
                j = f + 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i < 7) && (j < 7))
                {
                        tablero->getElem(++i, ++j, aux);
                }
                valido = ((aux == getTurno()) && (i != (int(c) + 1)) && (j != (int(f) + 1)));
        }
        return valido;
}

void tJuegoOtelo::mutaLineas(unsigned int c, unsigned int f)
{
        Turno rival, aux;
        int i, j;
        if(turno == Ja)
        {
                rival = Jb;
        }
        else rival = Ja;
        if(c > 0)
        {
                i = c - 1;
                tablero->getElem(i, f, aux);
                while((aux == rival) && (i > 0))
                {
                        tablero->getElem(--i, f, aux);
                }
                if((aux == getTurno()) && (i != (int(c) - 1)))
                {
                        for(i = i + 1; i < int(c); i++)
                        {
                                tablero->setElem(i, f, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if(c < 7)
        {
                i = c + 1;
                tablero->getElem(i, f, aux);
                while((aux == rival) && (i < 7))
                {
                        tablero->getElem(++i, f, aux);
                }
                if((aux == getTurno()) && (i != (int(c) + 1)))
                {
                        for(i = i - 1; i > int(c); i--)
                        {
                                tablero->setElem(i, f, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if(f > 0)
        {
                i = f - 1;
                tablero->getElem(c, i, aux);
                while((aux == rival) && (i > 0))
                {
                        tablero->getElem(c, --i, aux);
                }
                if((aux == getTurno()) && (i != (int(f) - 1)))
                {
                        for(i = i + 1; i < int(f); i++)
                        {
                                tablero->setElem(c, i, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if(f < 7)
        {
                i = f + 1;
                tablero->getElem(c, i, aux);
                while((aux == rival) && (i < 7))
                {
                        tablero->getElem(c, ++i, aux);
                }
                if((aux == getTurno()) && (i != (int(f) + 1)))
                {
                        for(i = i - 1; i > int(f); i--)
                        {
                                tablero->setElem(c, i, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if((c > 0) && (f > 0))
        {
                i = c - 1;
                j = f - 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i > 0) && (j > 0))
                {
                        tablero->getElem(--i, --j, aux);
                }
                if((aux == getTurno()) && (i != (int(c) - 1)) && (j != (int(f) - 1)))
                {
                        j = j + 1;
                        for(i = i + 1; i < int(c); i++)
                        {
                                tablero->setElem(i, j++, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if((c < 7) && (f > 0))
        {
                i = c + 1;
                j = f - 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i < 7) && (j > 0))
                {
                        tablero->getElem(++i, --j, aux);
                }
                if((aux == getTurno()) && (i != (int(c) + 1)) && (j != (int(f) - 1)))
                {
                        j = j + 1;
                        for(i = i - 1; i > int(c); i--)
                        {
                                tablero->setElem(i, j++, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if((c > 0) && (f < 7))
        {
                i = c - 1;
                j = f + 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i > 0) && (j < 7))
                {
                        tablero->getElem(--i, ++j, aux);
                }
                if((aux == getTurno()) && (i != (int(c) - 1)) && (j != (int(f) + 1)))
                {
                        j = j - 1;
                        for(i = i + 1; i < int(c); i++)
                        {
                                tablero->setElem(i, j--, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
        if((c < 7) && (f < 7))
        {
                i = c + 1;
                j = f + 1;
                tablero->getElem(i, j, aux);
                while((aux == rival) && (i < 7) && (j < 7))
                {
                        tablero->getElem(++i, ++j, aux);
                }
                if((aux == getTurno()) && (i != (int(c) + 1)) && (j != (int(f) + 1)))
                {
                        j = j - 1;
                        for(i = i - 1; i > int(c); i--)
                        {
                                tablero->setElem(i, j--, turno);
                                if(turno == Ja)
                                {
                                        ++fichas[0];
                                        --fichas[1];
                                }
                                else
                                {
                                        ++fichas[1];
                                        --fichas[0];
                                }
                        }
                }
        }
}

