//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJugadorAut3R.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

Casilla tJugAlea3R::juega(const tJuegoLogT2& EJ) throw (EJugador)
{
        Casilla cas;
        srand(time(0));
        randomize();
        cas.x = random(EJ.getCols());
        cas.y = random(EJ.getFils());
        return cas;
}

Casilla tJugConz3R::juega(const tJuegoLogT2& EJ) throw (EJugador)
{
        if(EJ.final()) throw EJugador();
        else
        {
                ArbolJT2 a(EJ, nivel, (FunHeuristicaT2)heuristica);
                Casilla cas = a.buscaMejorJugada();
                return cas;
        }
}

int heuris3R (const tJuego3Raya& EJ)
{
        Turno a1, a2, a3;
        int contador = 0;
        for(unsigned int i = 0; i < 3; i++)
        {
                EJ.getTablero()->getElem(i, 0, a1);
                EJ.getTablero()->getElem(i, 1, a2);
                EJ.getTablero()->getElem(i, 2, a3);
                heurisAux3R(contador, a1, a2, a3);
                EJ.getTablero()->getElem(0, i, a1);
                EJ.getTablero()->getElem(1, i, a2);
                EJ.getTablero()->getElem(2, i, a3);
                heurisAux3R(contador, a1, a2, a3);
        }
        EJ.getTablero()->getElem(0, 0, a1);
        EJ.getTablero()->getElem(1, 1, a2);
        EJ.getTablero()->getElem(2, 2, a3);
        heurisAux3R(contador, a1, a2, a3);
        EJ.getTablero()->getElem(0, 2, a1);
        EJ.getTablero()->getElem(1, 1, a2);
        EJ.getTablero()->getElem(2, 0, a3);
        heurisAux3R(contador, a1, a2, a3);
        return contador;
}

void heurisAux3R(int& cont, Turno a1, Turno a2, Turno a3)
{
        int x = 0, y = 1;
        if((a1 != Ja) && (a2 != Ja) && (a3 != Ja))
        {
                if(a1 == Jb) ++x;
                if(a2 == Jb) ++x;
                if(a3 == Jb) ++x;
                if(x > 0)
                {
                        for(x; x > 0; x--) y *= 10;
                        cont += y;
                        y = 1;
                }
        }
        else
        {
                if((a1 != Jb) && (a2 != Jb) && (a2 != Jb))
                {
                        if(a1 == Ja) ++x;
                        if(a2 == Ja) ++x;
                        if(a3 == Ja) ++x;
                        if(x > 0)
                        {
                        for(x; x > 0; x--) y *= 10;
                                cont -= y;
                                y = 1;
                        }
                }
        }
}
