//---------------------------------------------------------------------------

#ifndef UtJugadorAutOtH
#define UtJugadorAutOtH

#include "UtJugadorAutT2.h"
#include "UtArbolJT2.h"
#include "UtJuegoOtelo.h"
//---------------------------------------------------------------------------

class tJugadorAutOt: public tJugadorAutT2
{
public:
        tJugadorAutOt() {};
        ~tJugadorAutOt() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador) = 0;
};

class tJugAleaOt: public tJugadorAutOt
{
public:
        tJugAleaOt() {};
        ~tJugAleaOt() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador);
};

typedef int (*FunHeuristicaOt)(const tJuegoOtelo&);

int heurisOt (const tJuegoOtelo& EJ);

class tJugConzOt: public tJugadorAutOt
{
public:
        tJugConzOt(int nivel = 2) {this->nivel = nivel; heuristica = heurisOt;};
        ~tJugConzOt() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador);

private:
        int nivel;
        FunHeuristicaOt heuristica;
};

#endif
