//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "tForPrincp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
        try
        {
                if(jugando && !partida->fin() && ((partida->getTurno() == Ja) || dosJug ))
                {
                        delete backup;
                        backup = partida->clona();
                        Casilla ca = interfaz->dameCasilla(X, Y);
                        partida->aplicaJugada(ca);
                        interfaz->muestraEstado(*partida);
                        jugadas.push(ca);
                        if(!partida->fin() && !dosJug)
                        {
                                bool seguro;
                                do
                                {
                                        seguro = false;
                                        ca = jugador->juega(*partida);
                                        try
                                        {
                                                partida->aplicaJugada(ca);
                                        }
                                        catch (EJuego) {seguro = true;}
                                } while (seguro);
                                jugadas.push(ca);
                                Sleep(1000);
                                interfaz->muestraEstado(*partida);
                        }
                        if(partida->fin())
                        {
                                switch(partida->getTurno())
                                {
                                        case Ja:
                                                if(!dosJug) ShowMessage("Felicidades! Ha ganado!");
                                                else ShowMessage("Felicidades, jugador 1! Ha ganado!");
                                                break;
                                        case Jb:
                                                if(!dosJug) ShowMessage("Oooh... Ha perdido!");
                                                else ShowMessage("Felicidades, jugador 2! Ha ganado!");
                                                break;
                                }
                        }
                }
        }
        catch (EInterfaz) {ShowMessage("Error de interfaz.");}
        catch (EJuego) {ShowMessage("Movimiento no vlido.");}
        catch (EJugador) {ShowMessage("Error del jugador.");}
        catch (ErrRango) {ShowMessage("Haga clic dentro de los limites del tablero.");}
        catch (Error) {ShowMessage("Epic fail.");}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        partida = backup = NULL;
        interfaz = NULL;
        jugador = NULL;
        configuradoP = configuradoJ = jugando = dosJug = false;
        nomFich = "";
        OpenDlg->Filter = "Ficheros de juego (*.jt2)|*.JT2";
        SaveDlg->Filter = "Ficheros binarios (*.jt2)|*.JT2";
        SaveDlg->DefaultExt = ("jt2", "jt2");
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        if(typeid(*Owner) == typeid(TForm1))
        {
                dynamic_cast<TForm1*>(Owner)->destroyForm(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Conecta41Click(TObject *Sender)
{
        reset();
        juego = conect4;
        configuradoP = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Aleatorio1Click(TObject *Sender)
{
        reset();
        jugon = alea;
        configuradoJ = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Usuario1Click(TObject *Sender)
{
        primero = Ja;
        iniciaPartida(Ja);
        if(!jugando) ShowMessage("Debe seleccionar el juego y el jugador antes de continuar.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
        if(jugando)
        {
                interfaz->muestraEstado(*partida);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
        delete partida;
        delete backup;
        delete interfaz;
        delete jugador;
        for(unsigned int i = 0; i < lista.size(); i++)
        {
                delete lista.at(i);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Ordenador1Click(TObject *Sender)
{
        iniciaPartida(Jb);
        if(jugando)
        {
                primero = Jb;
                bool seguro;
                do
                {
                        seguro = false;
                        Casilla cb = jugador->juega(*partida);
                        try
                        {
                                partida->aplicaJugada(cb);
                        }
                        catch (EJuego) {seguro = true;}
                } while (seguro);
                Sleep(1000);
                interfaz->muestraEstado(*partida);
        }
        else ShowMessage("Debe seleccionar el juego y el jugador antes de continuar.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Salir2Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void TForm1::iniciaPartida(Turno t)
{
        if(configuradoP && configuradoJ)
        {
                if(partida != NULL)
                {
                        delete partida;
                        partida = NULL;
                }
                if(interfaz != NULL)
                {
                        delete interfaz;
                        interfaz = NULL;
                }
                if(jugador != NULL)
                {
                        delete jugador;
                        jugador = NULL;
                }
                if(backup != NULL)
                {
                        delete backup;
                        backup = NULL;
                }
                nomFich = "";
                jugadas.clear();
                Guardar1->Enabled = false;

                switch (juego)
                {
                        case conect4:
                                partida = new tJuegoConecta4(8, 6, t);
                                backup = new tJuegoConecta4(8, 6, t);
                                ClientHeight = tInterfazGrafC4::altoTablero + 50;
                                ClientWidth = tInterfazGrafC4::anchoTablero;
                                interfaz = new tInterfazGrafC4(this->Canvas);
                                interfaz->muestraEstado(*partida);
                                if(!dosJug)
                                {
                                        switch (jugon)
                                        {
                                                case alea:
                                                        jugador = new tJugAleaC4;
                                                        break;
                                                case cnzudo:
                                                        jugador = new tJugConzC4(nivel);
                                                        break;
                                        }
                                }
                                Caption = "Juegos reunidos - Conecta 4";
                                break;
                        case tresER:
                                partida = new tJuego3Raya(t);
                                backup = new tJuego3Raya(t);
                                ClientHeight = tInterfazGraf3R::altoTablero + 50;
                                ClientWidth = tInterfazGraf3R::anchoTablero;
                                interfaz = new tInterfazGraf3R(this->Canvas);
                                interfaz->muestraEstado(*partida);
                                if(!dosJug)
                                {
                                        switch (jugon)
                                        {
                                                case alea:
                                                        jugador = new tJugAlea3R;
                                                        break;
                                                case cnzudo:
                                                        jugador = new tJugConz3R(nivel);
                                                        break;
                                        }
                                }
                                Caption = "Juegos reunidos - Tres en Raya";
                                break;
                        case otelo:
                                partida = new tJuegoOtelo(t);
                                backup = new tJuegoOtelo(t);
                                ClientHeight = tInterfazGrafOt::altoTablero + 50;
                                ClientWidth = tInterfazGrafOt::anchoTablero;
                                interfaz = new tInterfazGrafOt(this->Canvas);
                                interfaz->muestraEstado(*partida);
                                if(!dosJug)
                                {
                                        switch (jugon)
                                        {
                                                case alea:
                                                        jugador = new tJugAleaOt;
                                                        break;
                                                case cnzudo:
                                                        jugador = new tJugConzOt(nivel);
                                                        break;
                                        }
                                }
                                Caption = "Juegos reunidos - Otelo";
                                break;
                }
                jugando = true;
        }
}
void __fastcall TForm1::Deshacer1Click(TObject *Sender)
{
        if(jugando)
        {
                tJuegoLogT2 *aux = partida;
                partida = backup;
                backup = aux;
                interfaz->muestraEstado(*partida);
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::GuardarComo1Click(TObject *Sender)
{
        if(SaveDlg->Execute())
        {
                nomFich = SaveDlg->FileName;
                Guardar1->Enabled = true;
                TForm1::Guardar1Click(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Guardar1Click(TObject *Sender)
{
        if(jugando)
        {
                ofstream sal;
                sal.open(nomFich.c_str(), ios::binary);
                if(sal.is_open())
                {
                        unsigned int size = jugadas.size();
                        Casilla aux;
                        sal.write((char *) & juego, sizeof(enuJuego));
                        sal.write((char *) & dosJug, sizeof(bool));
                        sal.write((char *) & jugon, sizeof(enuJugador));
                        sal.write((char *) & nivel, sizeof(enuNivel));
                        sal.write((char *) & primero, sizeof(Turno));
                        sal.write((char *) & size, sizeof(unsigned int));
                        jugadas.iniciaIter();
                        while(jugadas.actualIter(aux))
                        {
                                sal.write((char *) & aux, sizeof(Casilla));
                                jugadas.avanzaIter();
                        }
                }
                sal.close();
        }
        else ShowMessage("Debe estar jugando a una partida para poder guardar su estado.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Cargar1Click(TObject *Sender)
{
        if(OpenDlg->Execute())
        {
                nomFich = OpenDlg->FileName;
                ifstream ent;
                ent.open(nomFich.c_str(), ios::binary);
                if(ent.is_open())
                {
                        unsigned int size;
                        Casilla aux;
                        configuradoJ = configuradoP = true;
                        ent.read((char *) & juego, sizeof(enuJuego));
                        ent.read((char *) & dosJug, sizeof(bool));
                        ent.read((char *) & jugon, sizeof(enuJugador));
                        ent.read((char *) & nivel, sizeof(enuNivel));
                        ent.read((char *) & primero, sizeof(Turno));
                        ent.read((char *) & size, sizeof(unsigned int));
                        if(dosJug) ShowMessage("Aviso: Cargando una partida para dos jugadores humanos.");
                        iniciaPartida(primero);
                        while(jugadas.size() < size)
                        {
                                if(partida->getTurno() == Ja)
                                {
                                        delete backup;
                                        backup = partida->clona();
                                }
                                ent.read((char *) & aux, sizeof(Casilla));
                                partida->aplicaJugada(aux);
                                jugadas.push(aux);
                                interfaz->muestraEstado(*partida);
                                Sleep(1000);
                        }
                        Guardar1->Enabled = true;
                        if(dosJug)
                        {
                                switch(partida->getTurno())
                                {
                                        case Ja:
                                                ShowMessage("Ahora le toca al jugador 1.");
                                                break;
                                        case Jb:
                                                ShowMessage("Ahora le toca al jugador 2.");
                                                break;
                                }
                        }
                        else ShowMessage("Su turno!");
                }
                ent.close();
        }
}
//---------------------------------------------------------------------------

void TForm1::destroyForm(TForm1* form)
{
        unsigned int pos;
        TForm1::lista.find(form, pos);
        TForm1::lista.erase(pos);
        delete form;
}

void __fastcall TForm1::OtraVentana1Click(TObject *Sender)
{
        TForm1* aux = new TForm1(this);
        aux->Left = this->Left + 30;
        aux->Top = this->Top + 30;
        TForm1::lista.insert(aux);
        aux->Show();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Bajo1Click(TObject *Sender)
{
        reset();
        jugon = cnzudo;
        nivel = bajo;
        configuradoJ = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Medio1Click(TObject *Sender)
{
        reset();
        jugon = cnzudo;
        nivel = medio;
        configuradoJ = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Alto1Click(TObject *Sender)
{
        reset();
        jugon = cnzudo;
        nivel = alto;
        configuradoJ = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TresenRaya1Click(TObject *Sender)
{
        reset();
        juego = tresER;
        configuradoP = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Otello1Click(TObject *Sender)
{
        reset();
        juego = otelo;
        configuradoP = true;
}
//---------------------------------------------------------------------------

void TForm1::reset()
{
        if(dosJug) configuradoJ = false;
        jugando = false;
        dosJug = false;
        delete backup;
        backup = NULL;
        nomFich = "";
        Repaint();
}
void __fastcall TForm1::Dosjugadores1Click(TObject *Sender)
{
        configuradoJ = true;
        dosJug = true;
        primero = Ja;
        iniciaPartida(Ja);
        if(!jugando) ShowMessage("Debe seleccionar el juego y el jugador antes de continuar.");
}
//---------------------------------------------------------------------------

